Index: /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90
===================================================================
--- /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 5104)
+++ /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 5105)
@@ -1710,114 +1773,387 @@
    
 
-       CALL wrk_alloc( jpi, jpj, jpk, zmask, zsurf )
+       !CALL wrk_alloc( jpi, jpj, jpk, zmask, zsurf )
 
        SELECT CASE ( cd_type )
-          CASE( 'W' )
-              zmask(:,:,1) = p_mask(:,:,1) 
-              DO jk = 2, jpk
-                 zmask(:,:,jk) = p_mask(:,:,jk-1) 
-              ENDDO
-           CASE DEFAULT
-              DO jk = 1, jpk
-                 zmask(:,:,jk) = p_mask(:,:,jk) 
-              ENDDO
+
+         CASE ('T')
+
+            DO jk = 1 , jpk
+               DO ji = nistr, niend, nn_factx
+
+                  ii   = ( ji - mis_crs(2) ) * rfactx_r + 2
+                  IF (nldj_crs == 1 .AND. (( mje_crs(2) - mjs_crs(2) ) < 2)) THEN     !!cc bande du sud style ORCA2
+
+                  IF ( mje_crs(2) - mjs_crs(2) == 1 ) THEN
+
+                    jj = mje_crs(2)
+
+
+                    ze3crs = MAX(  p_e3(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk),  &
+                        &          p_e3(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk),  &
+                        &          p_e3(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk))
+
+                    p_e3_max_crs(ii,2,jk) = ze3crs
+
+                    ze3crs =  p_e3(ji  ,jj  ,jk) * p_e1(ji  ,jj  ) * p_e2(ji  ,jj  ) * p_mask(ji  ,jj  ,jk) +  &
+                        &     p_e3(ji+1,jj  ,jk) * p_e1(ji+1,jj  ) * p_e2(ji+1,jj  ) * p_mask(ji+1,jj  ,jk) +  &
+                        &     p_e3(ji+2,jj  ,jk) * p_e1(ji+2,jj  ) * p_e2(ji+2,jj  ) * p_mask(ji+2,jj  ,jk)
+
+
+                    p_e3_crs(ii,2,jk) = ze3crs / p_sfc_crs(ii,2,jk)
+                  ENDIF
+                  ELSE
+                     jj = mjs_crs(2)
+
+                     ze3crs = MAX( p_e3(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk),  &
+                        &          p_e3(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk),  &
+                        &          p_e3(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk),  &
+                        &          p_e3(ji  ,jj+1,jk) * p_mask(ji  ,jj+1,jk),  &
+                        &          p_e3(ji+1,jj+1,jk) * p_mask(ji+1,jj+1,jk),  &
+                        &          p_e3(ji+2,jj+1,jk) * p_mask(ji+2,jj+1,jk),  &
+                        &          p_e3(ji  ,jj+2,jk) * p_mask(ji  ,jj+2,jk),  &
+                        &          p_e3(ji+1,jj+2,jk) * p_mask(ji+1,jj+2,jk),  &
+                        &          p_e3(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk) )
+
+                     p_e3_max_crs(ii,2,jk) = ze3crs
+
+                     ze3crs =  p_e3(ji  ,jj  ,jk) * p_e1(ji  ,jj  ) * p_e2(ji  ,jj  ) * p_mask(ji  ,jj  ,jk) +  &
+                        &      p_e3(ji+1,jj  ,jk) * p_e1(ji+1,jj  ) * p_e2(ji+1,jj  ) * p_mask(ji+1,jj  ,jk) +  &
+                        &      p_e3(ji+2,jj  ,jk) * p_e1(ji+2,jj  ) * p_e2(ji+2,jj  ) * p_mask(ji+2,jj  ,jk) +  &
+                        &      p_e3(ji  ,jj+1,jk) * p_e1(ji  ,jj+1) * p_e2(ji  ,jj+1) * p_mask(ji  ,jj+1,jk) +  &
+                        &      p_e3(ji+1,jj+1,jk) * p_e1(ji+1,jj+1) * p_e2(ji+1,jj+1) * p_mask(ji+1,jj+1,jk) +  &
+                        &      p_e3(ji+2,jj+1,jk) * p_e1(ji+2,jj+1) * p_e2(ji+2,jj+1) * p_mask(ji+2,jj+1,jk) +  &
+                        &      p_e3(ji  ,jj+2,jk) * p_e1(ji  ,jj+2) * p_e2(ji  ,jj+2) * p_mask(ji  ,jj+2,jk) +  &
+                        &      p_e3(ji+1,jj+2,jk) * p_e1(ji+1,jj+2) * p_e2(ji+1,jj+2) * p_mask(ji+1,jj+2,jk) +  &
+                        &      p_e3(ji+2,jj+2,jk) * p_e1(ji+2,jj+2) * p_e2(ji+2,jj+2) * p_mask(ji+2,jj+2,jk)
+
+                       p_e3_crs(ii,2,jk) = ze3crs / p_sfc_crs(ii,2,jk)
+                  ENDIF
+
+                  DO jj = njstr, njend, nn_facty
+                     ii   = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
+                     ij   = ( jj - njstr ) * rfacty_r + 3
+                     ijje = mje_crs(ij)
+                     ijie = mie_crs(ii)
+                     !  
+                     ze3crs = MAX( p_e3(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk),  &
+                        &          p_e3(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk),  &
+                        &          p_e3(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk),  &
+                        &          p_e3(ji  ,jj+1,jk) * p_mask(ji  ,jj+1,jk),  &
+                        &          p_e3(ji+1,jj+1,jk) * p_mask(ji+1,jj+1,jk),  &
+                        &          p_e3(ji+2,jj+1,jk) * p_mask(ji+2,jj+1,jk),  &
+                        &          p_e3(ji  ,jj+2,jk) * p_mask(ji  ,jj+2,jk),  &
+                        &          p_e3(ji+1,jj+2,jk) * p_mask(ji+1,jj+2,jk),  &
+                        &          p_e3(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk) )
+
+                     p_e3_max_crs(ii,ij,jk) = ze3crs
+                     ze3crs =  p_e3(ji  ,jj  ,jk) * p_e1(ji  ,jj  ) * p_e2(ji  ,jj  ) * p_mask(ji  ,jj  ,jk) +  &
+                        &      p_e3(ji+1,jj  ,jk) * p_e1(ji+1,jj  ) * p_e2(ji+1,jj  ) * p_mask(ji+1,jj  ,jk) +  &
+                        &      p_e3(ji+2,jj  ,jk) * p_e1(ji+2,jj  ) * p_e2(ji+2,jj  ) * p_mask(ji+2,jj  ,jk) +  &
+                        &      p_e3(ji  ,jj+1,jk) * p_e1(ji  ,jj+1) * p_e2(ji  ,jj+1) * p_mask(ji  ,jj+1,jk) +  &
+                        &      p_e3(ji+1,jj+1,jk) * p_e1(ji+1,jj+1) * p_e2(ji+1,jj+1) * p_mask(ji+1,jj+1,jk) +  &
+                        &      p_e3(ji+2,jj+1,jk) * p_e1(ji+2,jj+1) * p_e2(ji+2,jj+1) * p_mask(ji+2,jj+1,jk) +  &
+                        &      p_e3(ji  ,jj+2,jk) * p_e1(ji  ,jj+2) * p_e2(ji  ,jj+2) * p_mask(ji  ,jj+2,jk) +  &
+                        &      p_e3(ji+1,jj+2,jk) * p_e1(ji+1,jj+2) * p_e2(ji+1,jj+2) * p_mask(ji+1,jj+2,jk) +  &
+                        &      p_e3(ji+2,jj+2,jk) * p_e1(ji+2,jj+2) * p_e2(ji+2,jj+2) * p_mask(ji+2,jj+2,jk)
+
+                       p_e3_crs(ii,ij,jk) = ze3crs / p_sfc_crs(ii,ij,jk)
+
+                  ENDDO
+               ENDDO
+            ENDDO
+
+         CASE ('U')
+
+         DO jk = 1 , jpk
+               DO ji = nistr, niend, nn_factx
+                 ii   = ( ji - mis_crs(2) ) * rfactx_r + 2
+                  IF (nldj_crs == 1 .AND. (( mje_crs(2) - mjs_crs(2) ) < 2)) THEN     !!cc bande du sud style ORCA2
+
+                     IF ( mje_crs(2) - mjs_crs(2) == 1 ) THEN
+
+                    jj = mje_crs(2)
+
+
+                    ze3crs = p_e3(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk)
+
+                    p_e3_max_crs(ii,2,jk) = ze3crs
+
+                    ze3crs =  p_e3(ji+2,jj  ,jk) * p_e1(ji+2,jj  ) * p_e2(ji+2,jj  ) * p_mask(ji+2,jj  ,jk)
+
+
+                     p_e3_crs(ii,2,jk) = ze3crs / p_sfc_crs(ii,2,jk)
+                     ENDIF
+                  ELSE
+                     jj = mjs_crs(2)
+
+                     ze3crs = MAX( p_e3(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk),  &
+                                   p_e3(ji+2,jj+1,jk) * p_mask(ji+2,jj+1,jk),  &
+                                   p_e3(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk) )
+
+                     p_e3_max_crs(ii,2,jk) = ze3crs
+
+                     ze3crs =  p_e3(ji+2,jj  ,jk) * p_e1(ji+2,jj  ) * p_e2(ji+2,jj  ) * p_mask(ji+2,jj  ,jk) +  &
+                        &      p_e3(ji+2,jj+1,jk) * p_e1(ji+2,jj+1) * p_e2(ji+2,jj+1) * p_mask(ji+2,jj+1,jk) +  &
+                        &      p_e3(ji+2,jj+2,jk) * p_e1(ji+2,jj+2) * p_e2(ji+2,jj+2) * p_mask(ji+2,jj+2,jk)
+
+                       p_e3_crs(ii,2,jk) = ze3crs / p_sfc_crs(ii,2,jk)
+                  ENDIF
+                  DO jj = njstr, njend, nn_facty
+                     ii   = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
+                     ij   = ( jj - njstr ) * rfacty_r + 3
+                     ijje = mje_crs(ij)
+                     ijie = mie_crs(ii)
+                     !  
+                     ze3crs = MAX( p_e3(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk),  &
+                        &          p_e3(ji+2,jj+1,jk) * p_mask(ji+2,jj+1,jk),  &
+                        &          p_e3(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk) )
+
+                     p_e3_max_crs(ii,ij,jk) = ze3crs
+
+                     ze3crs =  p_e3(ji+2,jj  ,jk) * p_e1(ji+2,jj  ) * p_e2(ji+2,jj  ) * p_mask(ji+2,jj  ,jk) +  &
+                        &      p_e3(ji+2,jj+1,jk) * p_e1(ji+2,jj+1) * p_e2(ji+2,jj+1) * p_mask(ji+2,jj+1,jk) +  &
+                        &      p_e3(ji+2,jj+2,jk) * p_e1(ji+2,jj+2) * p_e2(ji+2,jj+2) * p_mask(ji+2,jj+2,jk)
+
+                       p_e3_crs(ii,ij,jk) = ze3crs / p_sfc_crs(ii,ij,jk)
+
+                  ENDDO
+               ENDDO
+            ENDDO
+
+         CASE ('V')
+         DO jk = 1 , jpk
+               DO ji = nistr, niend, nn_factx
+
+                  ii   = ( ji - mis_crs(2) ) * rfactx_r + 2
+                  IF (nldj_crs == 1 .AND. (( mje_crs(2) - mjs_crs(2) ) < 2)) THEN     !!cc bande du sud style ORCA2
+
+                     IF ( mje_crs(2) - mjs_crs(2) == 1 ) THEN
+
+                    jj = mje_crs(2)
+
+
+                    ze3crs = MAX(  p_e3(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk),  &
+                        &          p_e3(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk),  &
+                        &          p_e3(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk))
+
+                    p_e3_max_crs(ii,2,jk) = ze3crs
+
+                    ze3crs =  p_e3(ji  ,jj  ,jk) * p_e1(ji  ,jj  ) * p_e2(ji  ,jj  ) * p_mask(ji  ,jj  ,jk) +  &
+                        &     p_e3(ji+1,jj  ,jk) * p_e1(ji+1,jj  ) * p_e2(ji+1,jj  ) * p_mask(ji+1,jj  ,jk) +  &
+                        &     p_e3(ji+2,jj  ,jk) * p_e1(ji+2,jj  ) * p_e2(ji+2,jj  ) * p_mask(ji+2,jj  ,jk)
+
+
+                     p_e3_crs(ii,2,jk) = ze3crs / p_sfc_crs(ii,2,jk)
+                     ENDIF
+                  ELSE
+                     jj = mjs_crs(2)
+
+                     ze3crs = MAX( p_e3(ji  ,jj+2,jk) * p_mask(ji  ,jj+2,jk),  &
+                        &          p_e3(ji+1,jj+2,jk) * p_mask(ji+1,jj+2,jk),  &
+                        &          p_e3(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk) )
+
+                     p_e3_max_crs(ii,2,jk) = ze3crs
+
+                     ze3crs =  p_e3(ji  ,jj+2,jk) * p_e1(ji  ,jj+2) * p_e2(ji  ,jj+2) * p_mask(ji  ,jj+2,jk) +  &
+                        &      p_e3(ji+1,jj+2,jk) * p_e1(ji+1,jj+2) * p_e2(ji+1,jj+2) * p_mask(ji+1,jj+2,jk) +  &
+                        &      p_e3(ji+2,jj+2,jk) * p_e1(ji+2,jj+2) * p_e2(ji+2,jj+2) * p_mask(ji+2,jj+2,jk)
+
+                       p_e3_crs(ii,2,jk) = ze3crs / p_sfc_crs(ii,2,jk)
+                  ENDIF
+
+                  DO jj = njstr, njend, nn_facty
+                     ii   = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
+                     ij   = ( jj - njstr ) * rfacty_r + 3
+                     ijje = mje_crs(ij)
+                     ijie = mie_crs(ii)
+                     !  
+                     ze3crs = MAX( p_e3(ji  ,jj+2,jk) * p_mask(ji  ,jj+2,jk),  &
+                        &          p_e3(ji+1,jj+2,jk) * p_mask(ji+1,jj+2,jk),  &
+                        &          p_e3(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk) )
+
+                     p_e3_max_crs(ii,ij,jk) = ze3crs
+
+                     ze3crs =  p_e3(ji  ,jj+2,jk) * p_e1(ji  ,jj+2) * p_e2(ji  ,jj+2) * p_mask(ji  ,jj+2,jk) +  &
+                        &      p_e3(ji+1,jj+2,jk) * p_e1(ji+1,jj+2) * p_e2(ji+1,jj+2) * p_mask(ji+1,jj+2,jk) +  &
+                        &      p_e3(ji+2,jj+2,jk) * p_e1(ji+2,jj+2) * p_e2(ji+2,jj+2) * p_mask(ji+2,jj+2,jk)
+
+                       p_e3_crs(ii,ij,jk) = ze3crs / p_sfc_crs(ii,ij,jk)
+
+                  ENDDO
+               ENDDO
+            ENDDO
+         CASE ('W')
+
+            DO jk = 2 , jpk
+               DO ji = nistr, niend, nn_factx
+               ii   = ( ji - mis_crs(2) ) * rfactx_r + 2
+               IF (nldj_crs == 1 .AND. (( mje_crs(2) - mjs_crs(2) ) < 2)) THEN     !!cc bande du sud style ORCA2
+
+                 IF ( mje_crs(2) - mjs_crs(2) == 1 ) THEN
+
+                    jj = mje_crs(2)
+
+
+                    ze3crs = MAX(  p_e3(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk-1),  &
+                        &          p_e3(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk-1),  &
+                        &          p_e3(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk-1))
+
+                     p_e3_max_crs(ii,2,jk) = ze3crs
+
+                     ze3crs =  p_e3(ji  ,jj  ,jk) * p_e1(ji  ,jj  ) * p_e2(ji  ,jj  ) * p_mask(ji  ,jj  ,jk-1) +  &
+                        &      p_e3(ji+1,jj  ,jk) * p_e1(ji+1,jj  ) * p_e2(ji+1,jj  ) * p_mask(ji+1,jj  ,jk-1) +  &
+                        &      p_e3(ji+2,jj  ,jk) * p_e1(ji+2,jj  ) * p_e2(ji+2,jj  ) * p_mask(ji+2,jj  ,jk-1)
+
+
+                       p_e3_crs(ii,2,jk) = ze3crs / p_sfc_crs(ii,2,jk)
+                  ENDIF
+               ELSE
+                  jj = mjs_crs(2)
+
+                  ze3crs = MAX( p_e3(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk-1),  &
+                     &          p_e3(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk-1),  &
+                     &          p_e3(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk-1),  &
+                     &          p_e3(ji  ,jj+1,jk) * p_mask(ji  ,jj+1,jk-1),  &
+                     &          p_e3(ji+1,jj+1,jk) * p_mask(ji+1,jj+1,jk-1),  &
+                     &          p_e3(ji+2,jj+1,jk) * p_mask(ji+2,jj+1,jk-1),  &
+                     &          p_e3(ji  ,jj+2,jk) * p_mask(ji  ,jj+2,jk-1),  &
+                     &          p_e3(ji+1,jj+2,jk) * p_mask(ji+1,jj+2,jk-1),  &
+                     &          p_e3(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk-1) )
+
+                  p_e3_max_crs(ii,2,jk) = ze3crs
+                  ze3crs =  p_e3(ji  ,jj  ,jk) * p_e1(ji  ,jj  ) * p_e2(ji  ,jj  ) * p_mask(ji  ,jj  ,jk-1) +  &
+                     &      p_e3(ji+1,jj  ,jk) * p_e1(ji+1,jj  ) * p_e2(ji+1,jj  ) * p_mask(ji+1,jj  ,jk-1) +  &
+                     &      p_e3(ji+2,jj  ,jk) * p_e1(ji+2,jj  ) * p_e2(ji+2,jj  ) * p_mask(ji+2,jj  ,jk-1) +  &
+                     &      p_e3(ji  ,jj+1,jk) * p_e1(ji  ,jj+1) * p_e2(ji  ,jj+1) * p_mask(ji  ,jj+1,jk-1) +  &
+                     &      p_e3(ji+1,jj+1,jk) * p_e1(ji+1,jj+1) * p_e2(ji+1,jj+1) * p_mask(ji+1,jj+1,jk-1) +  &
+                     &      p_e3(ji+2,jj+1,jk) * p_e1(ji+2,jj+1) * p_e2(ji+2,jj+1) * p_mask(ji+2,jj+1,jk-1) +  &
+                     &      p_e3(ji  ,jj+2,jk) * p_e1(ji  ,jj+2) * p_e2(ji  ,jj+2) * p_mask(ji  ,jj+2,jk-1) +  &
+                     &      p_e3(ji+1,jj+2,jk) * p_e1(ji+1,jj+2) * p_e2(ji+1,jj+2) * p_mask(ji+1,jj+2,jk-1) +  &
+                     &      p_e3(ji+2,jj+2,jk) * p_e1(ji+2,jj+2) * p_e2(ji+2,jj+2) * p_mask(ji+2,jj+2,jk-1)
+
+                  p_e3_crs(ii,2,jk) = ze3crs / p_sfc_crs(ii,2,jk)
+               ENDIF
+
+
+                  DO jj = njstr, njend, nn_facty
+                     ii   = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
+                     ij   = ( jj - njstr ) * rfacty_r + 3
+                     ijje = mje_crs(ij)
+                     ijie = mie_crs(ii)
+                     !  
+                     ze3crs = MAX( p_e3(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk-1),  &
+                        &          p_e3(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk-1),  &
+                        &          p_e3(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk-1),  &
+                        &          p_e3(ji  ,jj+1,jk) * p_mask(ji  ,jj+1,jk-1),  &
+                        &          p_e3(ji+1,jj+1,jk) * p_mask(ji+1,jj+1,jk-1),  &
+                        &          p_e3(ji+2,jj+1,jk) * p_mask(ji+2,jj+1,jk-1),  &
+                        &          p_e3(ji  ,jj+2,jk) * p_mask(ji  ,jj+2,jk-1),  &
+                        &          p_e3(ji+1,jj+2,jk) * p_mask(ji+1,jj+2,jk-1),  &
+                        &          p_e3(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk-1) )
+
+                     p_e3_max_crs(ii,ij,jk) = ze3crs
+
+                     ze3crs =  p_e3(ji  ,jj  ,jk) * p_e1(ji  ,jj  ) * p_e2(ji  ,jj  ) * p_mask(ji  ,jj  ,jk-1) +  &
+                        &      p_e3(ji+1,jj  ,jk) * p_e1(ji+1,jj  ) * p_e2(ji+1,jj  ) * p_mask(ji+1,jj  ,jk-1) +  &
+                        &      p_e3(ji+2,jj  ,jk) * p_e1(ji+2,jj  ) * p_e2(ji+2,jj  ) * p_mask(ji+2,jj  ,jk-1) +  &
+                        &      p_e3(ji  ,jj+1,jk) * p_e1(ji  ,jj+1) * p_e2(ji  ,jj+1) * p_mask(ji  ,jj+1,jk-1) +  &
+                        &      p_e3(ji+1,jj+1,jk) * p_e1(ji+1,jj+1) * p_e2(ji+1,jj+1) * p_mask(ji+1,jj+1,jk-1) +  &
+                        &      p_e3(ji+2,jj+1,jk) * p_e1(ji+2,jj+1) * p_e2(ji+2,jj+1) * p_mask(ji+2,jj+1,jk-1) +  &
+                        &      p_e3(ji  ,jj+2,jk) * p_e1(ji  ,jj+2) * p_e2(ji  ,jj+2) * p_mask(ji  ,jj+2,jk-1) +  &
+                        &      p_e3(ji+1,jj+2,jk) * p_e1(ji+1,jj+2) * p_e2(ji+1,jj+2) * p_mask(ji+1,jj+2,jk-1) +  &
+                        &      p_e3(ji+2,jj+2,jk) * p_e1(ji+2,jj+2) * p_e2(ji+2,jj+2) * p_mask(ji+2,jj+2,jk-1)
+
+                       p_e3_crs(ii,ij,jk) = ze3crs / p_sfc_crs(ii,ij,jk)
+
+                  ENDDO
+               ENDDO
+            ENDDO
+            DO ji = nistr, niend, nn_factx
+               ii   = ( ji - mis_crs(2) ) * rfactx_r + 2
+               IF (nldj_crs == 1 .AND. (( mje_crs(2) - mjs_crs(2) ) < 2)) THEN     !!cc bande du sud style ORCA2
+
+                 IF ( mje_crs(2) - mjs_crs(2) == 1 ) THEN
+
+                    jj = mje_crs(2)
+
+                    ze3crs = MAX(  p_e3(ji  ,jj  ,1) * p_mask(ji  ,jj  ,1),  &
+                        &          p_e3(ji+1,jj  ,1) * p_mask(ji+1,jj  ,1),  &
+                        &          p_e3(ji+2,jj  ,1) * p_mask(ji+2,jj  ,1))
+
+                    p_e3_max_crs(ii,2,1) = ze3crs
+
+                    ze3crs =  p_e3(ji  ,jj  ,1) * p_e1(ji  ,jj  ) * p_e2(ji  ,jj  ) * p_mask(ji  ,jj  ,1) +  &
+                        &      p_e3(ji+1,jj  ,1) * p_e1(ji+1,jj  ) * p_e2(ji+1,jj  ) * p_mask(ji+1,jj  ,1) +  &
+                        &      p_e3(ji+2,jj  ,1) * p_e1(ji+2,jj  ) * p_e2(ji+2,jj  ) * p_mask(ji+2,jj  ,1)
+
+                    p_e3_crs(ii,2,1) = ze3crs / p_sfc_crs(ii,2,1)
+                  ENDIF
+               ELSE
+                  jj = mjs_crs(2)
+
+                  ze3crs = MAX( p_e3(ji  ,jj  ,1) * p_mask(ji  ,jj  ,1),  &
+                     &          p_e3(ji+1,jj  ,1) * p_mask(ji+1,jj  ,1),  &
+                     &          p_e3(ji+2,jj  ,1) * p_mask(ji+2,jj  ,1),  &
+                     &          p_e3(ji  ,jj+1,1) * p_mask(ji  ,jj+1,1),  &
+                     &          p_e3(ji+1,jj+1,1) * p_mask(ji+1,jj+1,1),  &
+                     &          p_e3(ji+2,jj+1,1) * p_mask(ji+2,jj+1,1),  &
+                     &          p_e3(ji  ,jj+2,1) * p_mask(ji  ,jj+2,1),  &
+                     &          p_e3(ji+1,jj+2,1) * p_mask(ji+1,jj+2,1),  &
+                     &          p_e3(ji+2,jj+2,1) * p_mask(ji+2,jj+2,1) )
+
+                  p_e3_max_crs(ii,2,1) = ze3crs
+                  ze3crs =  p_e3(ji  ,jj  ,1) * p_e1(ji  ,jj  ) * p_e2(ji  ,jj  ) * p_mask(ji  ,jj  ,1) +  &
+                        &    p_e3(ji+1,jj  ,1) * p_e1(ji+1,jj  ) * p_e2(ji+1,jj  ) * p_mask(ji+1,jj  ,1) +  &
+                        &    p_e3(ji+2,jj  ,1) * p_e1(ji+2,jj  ) * p_e2(ji+2,jj  ) * p_mask(ji+2,jj  ,1) +  &
+                        &    p_e3(ji  ,jj+1,1) * p_e1(ji  ,jj+1) * p_e2(ji  ,jj+1) * p_mask(ji  ,jj+1,1) +  &
+                        &    p_e3(ji+1,jj+1,1) * p_e1(ji+1,jj+1) * p_e2(ji+1,jj+1) * p_mask(ji+1,jj+1,1) +  &
+                        &    p_e3(ji+2,jj+1,1) * p_e1(ji+2,jj+1) * p_e2(ji+2,jj+1) * p_mask(ji+2,jj+1,1) +  &
+                        &    p_e3(ji  ,jj+2,1) * p_e1(ji  ,jj+2) * p_e2(ji  ,jj+2) * p_mask(ji  ,jj+2,1) +  &
+                        &    p_e3(ji+1,jj+2,1) * p_e1(ji+1,jj+2) * p_e2(ji+1,jj+2) * p_mask(ji+1,jj+2,1) +  &
+                        &    p_e3(ji+2,jj+2,1) * p_e1(ji+2,jj+2) * p_e2(ji+2,jj+2) * p_mask(ji+2,jj+2,1)
+
+                   p_e3_crs(ii,2,1) = ze3crs / p_sfc_crs(ii,2,1)
+
+               ENDIF
+               DO jj = njstr, njend, nn_facty
+                  ii   = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
+                  ij   = ( jj - njstr ) * rfacty_r + 3
+                  ijje = mje_crs(ij)
+                  ijie = mie_crs(ii)
+                  !  
+                  ze3crs = MAX( p_e3(ji  ,jj  ,1) * p_mask(ji  ,jj  ,1),  &
+                     &          p_e3(ji+1,jj  ,1) * p_mask(ji+1,jj  ,1),  &
+                     &          p_e3(ji+2,jj  ,1) * p_mask(ji+2,jj  ,1),  &
+                     &          p_e3(ji  ,jj+1,1) * p_mask(ji  ,jj+1,1),  &
+                     &          p_e3(ji+1,jj+1,1) * p_mask(ji+1,jj+1,1),  &
+                     &          p_e3(ji+2,jj+1,1) * p_mask(ji+2,jj+1,1),  &
+                     &          p_e3(ji  ,jj+2,1) * p_mask(ji  ,jj+2,1),  &
+                     &          p_e3(ji+1,jj+2,1) * p_mask(ji+1,jj+2,1),  &
+                     &          p_e3(ji+2,jj+2,1) * p_mask(ji+2,jj+2,1) )
+
+                  p_e3_max_crs(ii,ij,1) = ze3crs
+
+                   ze3crs =  p_e3(ji  ,jj  ,1) * p_e1(ji  ,jj  ) * p_e2(ji  ,jj  ) * p_mask(ji  ,jj  ,1) +  &
+                        &    p_e3(ji+1,jj  ,1) * p_e1(ji+1,jj  ) * p_e2(ji+1,jj  ) * p_mask(ji+1,jj  ,1) +  &
+                        &    p_e3(ji+2,jj  ,1) * p_e1(ji+2,jj  ) * p_e2(ji+2,jj  ) * p_mask(ji+2,jj  ,1) +  &
+                        &    p_e3(ji  ,jj+1,1) * p_e1(ji  ,jj+1) * p_e2(ji  ,jj+1) * p_mask(ji  ,jj+1,1) +  &
+                        &    p_e3(ji+1,jj+1,1) * p_e1(ji+1,jj+1) * p_e2(ji+1,jj+1) * p_mask(ji+1,jj+1,1) +  &
+                        &    p_e3(ji+2,jj+1,1) * p_e1(ji+2,jj+1) * p_e2(ji+2,jj+1) * p_mask(ji+2,jj+1,1) +  &
+                        &    p_e3(ji  ,jj+2,1) * p_e1(ji  ,jj+2) * p_e2(ji  ,jj+2) * p_mask(ji  ,jj+2,1) +  &
+                        &    p_e3(ji+1,jj+2,1) * p_e1(ji+1,jj+2) * p_e2(ji+1,jj+2) * p_mask(ji+1,jj+2,1) +  &
+                        &    p_e3(ji+2,jj+2,1) * p_e1(ji+2,jj+2) * p_e2(ji+2,jj+2) * p_mask(ji+2,jj+2,1)
+
+                       p_e3_crs(ii,ij,1) = ze3crs / p_sfc_crs(ii,ij,1)
+
+               ENDDO
+            ENDDO
+        !              
        END SELECT
 
-       DO jk = 1, jpk
-          zsurf(:,:,jk) = p_e1(:,:) * p_e2(:,:) * p_e3(:,:,jk) 
-       ENDDO
-
-       IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
-          IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
-             je_2 = mje_crs(2)
-             DO jk = 1 , jpk
-                DO ji = nistr, niend, nn_factx
-                   ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                   ze3crs =   zsurf(ji  ,je_2,jk) * zmask(ji  ,je_2,jk)   &
-                        &   + zsurf(ji+1,je_2,jk) * zmask(ji+1,je_2,jk)   &
-                        &   + zsurf(ji+2,je_2,jk) * zmask(ji+2,je_2,jk) 
-
-                   p_e3_crs(ii,2,jk) = ze3crs / p_sfc_crs(ii,ij,jk)
-                   !
-                   ze3crs = MAX( p_e3(ji  ,je_2,jk) * zmask(ji  ,je_2,jk),  &
-                      &          p_e3(ji+1,je_2,jk) * zmask(ji+1,je_2,jk),  &
-                      &          p_e3(ji+2,je_2,jk) * zmask(ji+2,je_2,jk)  )
-                   !
-                   p_e3_max_crs(ii,2,jk) = ze3crs
-                ENDDO
-             ENDDO
-          ENDIF
-       ELSE
-          je_2 = mjs_crs(2)
-          DO jk = 1 , jpk
-             DO ji = nistr, niend, nn_factx
-                ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                ze3crs =  zsurf(ji  ,je_2  ,jk) * zmask(ji  ,je_2  ,jk)   &
-                   &    + zsurf(ji+1,je_2  ,jk) * zmask(ji+1,je_2  ,jk)   &
-                   &    + zsurf(ji+2,je_2  ,jk) * zmask(ji+2,je_2  ,jk)   &
-                   &    + zsurf(ji  ,je_2+1,jk) * zmask(ji  ,je_2+1,jk)   &
-                   &    + zsurf(ji+1,je_2+1,jk) * zmask(ji+1,je_2+1,jk)   &
-                   &    + zsurf(ji+2,je_2+1,jk) * zmask(ji+2,je_2+1,jk)   &
-                   &    + zsurf(ji  ,je_2+2,jk) * zmask(ji  ,je_2+2,jk)   &
-                   &    + zsurf(ji+1,je_2+2,jk) * zmask(ji+1,je_2+2,jk)   &
-                   &    + zsurf(ji+2,je_2+2,jk) * zmask(ji+2,je_2+2,jk)
-
-                p_e3_crs(ii,2,jk) = ze3crs / p_sfc_crs(ii,2,jk)
-                !
-                ze3crs = MAX( p_e3(ji  ,je_2  ,jk) * zmask(ji  ,je_2  ,jk),  &
-                   &          p_e3(ji+1,je_2  ,jk) * zmask(ji+1,je_2  ,jk),  &
-                   &          p_e3(ji+2,je_2  ,jk) * zmask(ji+2,je_2  ,jk),  &
-                   &          p_e3(ji  ,je_2+1,jk) * zmask(ji  ,je_2+1,jk),  &
-                   &          p_e3(ji+1,je_2+1,jk) * zmask(ji+1,je_2+1,jk),  &
-                   &          p_e3(ji+2,je_2+1,jk) * zmask(ji+2,je_2+1,jk),  &
-                   &          p_e3(ji  ,je_2+2,jk) * zmask(ji  ,je_2+2,jk),  &
-                   &          p_e3(ji+1,je_2+2,jk) * zmask(ji+1,je_2+2,jk),  &
-                   &          p_e3(ji+2,je_2+2,jk) * zmask(ji+2,je_2+2,jk) )
-               
-                p_e3_max_crs(ii,2,jk) = ze3crs
-                ENDDO
-             ENDDO
-          ENDIF
-          DO jk = 1 , jpk
-             DO jj = njstr, njend, nn_facty
-                DO ji = nistr, niend, nn_factx
-                   ii   = ( ji - mis_crs(2) ) * rfactx_r + 2          
-                   ij   = ( jj - njstr ) * rfacty_r + 3
-                   ze3crs =   zsurf(ji  ,jj  ,jk) * zmask(ji  ,jj  ,jk)   &
-                   &        + zsurf(ji+1,jj  ,jk) * zmask(ji+1,jj  ,jk)   &
-                   &        + zsurf(ji+2,jj  ,jk) * zmask(ji+2,jj  ,jk)   &
-                   &        + zsurf(ji  ,jj+1,jk) * zmask(ji  ,jj+1,jk)   &
-                   &        + zsurf(ji+1,jj+1,jk) * zmask(ji+1,jj+1,jk)   &
-                   &        + zsurf(ji+2,jj+1,jk) * zmask(ji+2,jj+1,jk)   &
-                   &        + zsurf(ji  ,jj+2,jk) * zmask(ji  ,jj+2,jk)   &
-                   &        + zsurf(ji+1,jj+2,jk) * zmask(ji+1,jj+2,jk)   &
-                   &        + zsurf(ji+2,jj+2,jk) * zmask(ji+2,jj+2,jk)
-
-                !cbr
-                !p_e3_crs(ii,ij,jk) = ze3crs / p_sfc_crs(ii,ij,jk)
-                IF( p_sfc_crs(ii,ij,jk) == 0.d0 )WRITE(narea+200,*)"crs_dom_e30 ",ii,ij,jk,p_sfc_crs(ii,ij,jk) ; call flush(narea+200)
-                IF( p_sfc_crs(ii,ij,jk) .NE. 0.d0 )THEN ;  p_e3_crs(ii,ij,jk) = ze3crs / p_sfc_crs(ii,ij,jk)
-                ELSE                                    ;  p_e3_crs(ii,ij,jk) =0.d0
-                ENDIF
-                !
-                ze3crs = MAX( p_e3(ji  ,jj  ,jk) * zmask(ji  ,jj  ,jk),  &
-                   &          p_e3(ji+1,jj  ,jk) * zmask(ji+1,jj  ,jk),  &
-                   &          p_e3(ji+2,jj  ,jk) * zmask(ji+2,jj  ,jk),  &
-                   &          p_e3(ji  ,jj+1,jk) * zmask(ji  ,jj+1,jk),  &
-                   &          p_e3(ji+1,jj+1,jk) * zmask(ji+1,jj+1,jk),  &
-                   &          p_e3(ji+2,jj+1,jk) * zmask(ji+2,jj+1,jk),  &
-                   &          p_e3(ji  ,jj+2,jk) * zmask(ji  ,jj+2,jk),  &
-                   &          p_e3(ji+1,jj+2,jk) * zmask(ji+1,jj+2,jk),  &
-                   &          p_e3(ji+2,jj+2,jk) * zmask(ji+2,jj+2,jk) )
-               
-                p_e3_max_crs(ii,ij,jk) = ze3crs
-             ENDDO
-          ENDDO
-       ENDDO
-                  
-       CALL crs_lbc_lnk( p_e3_crs    , cd_type, 1.0, pval=1.0 )  
-       CALL crs_lbc_lnk( p_e3_max_crs, cd_type, 1.0, pval=1.0 )  
+         CALL crs_lbc_lnk( p_e3_max_crs, cd_type, 1.0, pval=1.0 )
+         CALL crs_lbc_lnk( p_e3_crs    , cd_type, 1.0, pval=1.0 )
        !              
-       CALL wrk_dealloc( jpi, jpj, jpk, zsurf, zmask )
+       !CALL wrk_dealloc( jpi, jpj, jpk, zsurf, zmask )
        !
    END SUBROUTINE crs_dom_e3
@@ -1836,8 +2172,10 @@
       INTEGER  :: ji, jj, jk                   ! dummy loop indices
       INTEGER  :: ii, ij, je_2
+      INTEGER  :: iji,ijj
       REAL(wp), DIMENSION(:,:,:), POINTER :: zsurf, zsurfmsk   
       !!----------------------------------------------------------------  
       ! Initialize
-
+      p_surf_crs(:,:,:)=0._wp
+      p_surf_crs_msk(:,:,:)=0._wp
 
       CALL wrk_alloc( jpi, jpj, jpk, zsurf, zsurfmsk )
@@ -1849,7 +2187,9 @@
                zsurf(:,:,jk) = p_e1(:,:) * p_e2(:,:) 
             ENDDO
-            zsurfmsk(:,:,1) = zsurf(:,:,1) * p_mask(:,:,1) 
-            DO jk = 2, jpk
-               zsurfmsk(:,:,jk) = zsurf(:,:,jk) * p_mask(:,:,jk-1) 
+            !zsurfmsk(:,:,1) = zsurf(:,:,1) * p_mask(:,:,1) 
+            !cbr DO jk = 2, jpk
+            DO jk = 1, jpk
+               !cbr zsurfmsk(:,:,jk) = zsurf(:,:,jk) * p_mask(:,:,jk-1) 
+               zsurfmsk(:,:,jk) = zsurf(:,:,jk) * p_mask(:,:,jk) 
             ENDDO
 
@@ -1878,4 +2218,10 @@
             ENDDO
       END SELECT
+
+      WRITE(narea+200,*)"TOTO",nldj_crs,mjs_crs(1), mje_crs(1),mjs_crs(2), mje_crs(2),mjs_crs(3), mje_crs(3),mjs_crs(4), mje_crs(4) ; CALL FLUSH(narea+200)
+
+      SELECT CASE ( cd_type )
+
+      CASE ('W')
 
       IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
